# Introduction
These tests are designed to measure the performance of various ROS
mechanisms. 

# Design
1. The script `runtests.py` is the top-level script that runs the specified
tests and creates a summary of results.
2. Each test is supposed to run it's desired ROS nodes (using `roslaunch`) and
create a `foo.py` file containing the performance logs for the ROS node named
`foo`. 
3. The script `summarize.py` takes the logs created by a single test and
creates a set of stats for that test.
  1. In addition to creating a detailed log, `summarize.py` can print to stdout
  the comma separated list of stats it wants listed in a top-level summary of
  all tests. Typically this is used to generate a top-level `<average,min,max>`
  kind of summary for the whole test.
4. `runtests.py` also creates a unified `combinedLogs.csv` file

# Running the tests
Upon installation on the target, the `.ipk` creates the following directory structure:
~~~~
/opt/ros/indigo/share
    ros_tests
        runtests.py
	summarize.py
	package.xml
        launch
            client-server.launch
	    ion.launch
/opt/ros/indigo/lib
    ros_tests
        client
	server
~~~~
## Running One Test on Command Line
Sometimes it's useful to run a test from command line, e.g.:
- To see console and other logs
- To check of one or more ROS nodes die
- To modify test parameters
In such cases, roslaunch can be used. E.g. to run a simple "buffer" test:

~~~~
% cd /opt/ros/indigo
% source ros-env.sh
% roslaunch ros_tests client_server.launch logDir:=/tmp msgType:=buffer loopRate:=10 iterations:=10 transport:=tcp
~~~~

The arguments are, in order:
- ROS package name `ros_tests`
- Launch file name `client_server.launch`
- Where to log the results, `/tmp`
- What type of buffer to send, `buffer`
- The loop rate and iterations, and
- The transport type
This will create `/tmp/server.py` and `/tmp/client.py` as the two nodes' log files.

## Running Mutliple Tests using runtests
To run the tests, use the `-h` option on `runtests.py`. Then you can run a specific
test, or a test suite. E.g. to run the performance suite:

~~~~
% cd /opt/ros/indigo
% source ros-env.sh
% share/ros_tests/runtests.py -h
% share/ros_tests/runtests.py -s performance_suite
~~~~

This will create a bunch of logs in the `/opt/ros/indigo/logs` directory. The main types
of files in there are:

- `foo`: A directory for test foo. This should look like a python module so it can be
automatically loaded
  - `__init__.py`: Empty, but needed
  - `a.py`: Log generated by node 'a' in the test
  - `b.py`: Log generated by node 'b' in the test
- `foo.csv`: The file generated by 'summarize.py' after it analyzes `a.py` and `b.py`. Usually
an `average,min,max` result is printed to stdout, which is captured in the file `logs.csv`
- `logs.csv`: The one-line summary for each test
- `combinedLogs.csv`: A concatenation of all the CSV files, for plotting and later study

# Getting More Documentation
The Doxygen documentation for this code can be generated using v18,x of doxygen. 

If you don't have doxygen:
~~~~
% sudo apt-get install doxygen
~~~~

After installing doxygen:
~~~~
% cd ros-tests
% doxygen
% cd ./html
% <open index.html with browser> 
~~~~